<?php
namespace Dennis\Seeder\Domain\Model\Column;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Dennis Römmich <dennis@roemmich.eu>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
use Dennis\Seeder\Domain\Model\ColumnInterface;

/**
 * Interface OneToManyInterface
 *
 * @package Dennis\Seeder\Domain\Model\Column\OneToManyInterface
 */
interface OneToManyInterface extends ColumnInterface
{
    /**
     * @return string
     */
    public function getForeignTable();

    /**
     * @return string
     */
    public function getForeignTableWhere();

    /**
     * @return string
     */
    public function getForeignField();

    /**
     * @return array
     */
    public function getItems();

    /**
     * @return int
     */
    public function getMaxItems();

    /**
     * @return int
     */
    public function getMinItems();

    /**
     * @return int
     */
    public function getSize();
}
